MIPSparseField< Data_T > Class Template Reference

`#include <MIPField.h>`

Inheritance diagram for MIPSparseField< Data_T >:

## Public Member Functions

virtual FieldBase::Ptr | clone () const
| Returns a pointer to a copy of the field, pure virtual so ensure derived classes properly implement it.
Public Member Functions inherited from MIPField< SparseField< Data_T > >
void | clear ()
| Clears all the levels of the MIP field.
SparseField< Data_T >::Ptr | concreteMipLevel (const size_t level) const
| Returns a concretely typed pointer to a MIP level.
Data_T | fastMipValue (size_t level, int i, int j, int k) const
| Read access to voxel at a given MIP level.
virtual void | getVsMIPCoord (const V3f &vsP, const size_t level, V3f &outVsP) const
| Given a voxel space coordinate in the 0-level field, computes the coordinate in another level.
virtual bool | levelLoaded (const size_t level) const
| Whether a given MIP level is loaded.
virtual Field< Data_T >::Ptr | mipLevel (const size_t level) const
| Returns a MIP level field.
virtual V3i | mipResolution (size_t level) const
| Returns the resolution of a given MIP level.
virtual Data_T | mipValue (size_t level, int i, int j, int k) const
| Read access to a voxel in a given MIP level.
const SparseField< Data_T > * | rawMipLevel (const size_t level) const
| Returns a raw pointer to a MIP level.
void | setup (const FieldVec &fields)
| Sets up the MIP field given a set of non-MIP fields This call performs sanity checking to ensure that MIP properties are satisfied for each level. In this case, all MIP levels are available in memory.
void | setupLazyLoad (const ProxyVec &proxies, const typename LazyLoadAction< SparseField< Data_T > >::Vec &actions)
| Sets up the MIP field in lazy-load mode.
| MIPField ()
| Constructs an empty MIP field.
const MIPField & | operator= (const MIPField &rhs)
| Assignment operator.
virtual long long int | memSize () const
| Returns the memory usage (in bytes).
virtual void | mappingChanged ()
| We need to know if the mapping changed so that we may update the MIP levels' mappings.
virtual Data_T | value (int i, int j, int k) const
| Read access to a voxel. The coordinates are in integer voxel space .
virtual size_t | voxelCount () const
| Counts the number of voxels. For most fields, this is just the volume of the data window, but sparse data structures can override this to return a better value.
Public Member Functions inherited from MIPBase< SparseField< Data_T >::value_type >
size_t | lowestLevel () const
| Lowest MIP level to use.
| MIPBase ()
const V3i & | mipOffset () const
| Returns the base MIP offset.
size_t | numLevels () const
| Number of MIP levels.
void | setLowestLevel (size_t level)
| Sets the lowest MIP level to use. Defaults to zero, but can be set higher to prevent high resolution levels from being accessed.
void | setMIPOffset (const V3i &offset)
| Sets the base MIP offset. This is used to indicate where voxel space coordinate (0, 0, 0) really maps to.
Public Member Functions inherited from Field< Data_T >
const_iterator | cbegin () const
| Const iterator to first element. "cbegin" matches the tr1 c++ standard.
const_iterator | cbegin (const Box3i &subset) const
| Const iterator to first element of specific subset.
const_iterator | cend () const
| Const iterator pointing one element past the last valid one.
const_iterator | cend (const Box3i &subset) const
| Const iterator pointing one element past the last valid one (for a subset).
virtual std::string | dataTypeString () const
virtual | ~Field ()
| Dtor.
Public Member Functions inherited from FieldRes
V3i const | dataResolution () const
const Box3i & | dataWindow () const
| Returns the data window. Any coordinate inside this window is safe to pass to value() in the Field subclass.
const Box3i & | extents () const
| Returns the extents of the data. This signifies the relevant area that the data exists over. However, the data window (below) may be smaller than the extents, in which case it is only safe to call value() for those coordinate inside the data window.
| FieldRes ()
| This constructor ensures that we have a valid mapping at all times.
| FieldRes (const FieldRes &src)
| Base class copy constructor.
bool | isInBounds (int i, int j, int k) const
| Returns true is the indicies are in bounds of the data window.
FieldMapping::Ptr | mapping ()
| Returns a pointer to the mapping.
const FieldMapping::Ptr | mapping () const
| Returns a pointer to the mapping.
void | setMapping (FieldMapping::Ptr mapping)
| Sets the field's mapping.
Public Member Functions inherited from FieldBase
| FieldBase ()
| Constructor.
| FieldBase (const FieldBase &)
| Copy Constructor.
virtual | ~FieldBase ()
| Destructor.
virtual std::string | className () const =0
| Returns the class name of the object. Used by the class pool and when writing the data to disk.
virtual std::string | classType () const =0
| Returns the full class type string.
FieldMetadata & | metadata ()
| accessor to the m_metadata class
const FieldMetadata & | metadata () const
| Read only access to the m_metadata class.
void | copyMetadata (const FieldBase &field)
| Copies the metadata from a second field.
Public Member Functions inherited from RefBase
void | ref () const
| Used by boost::intrusive_pointer.
size_t | refcnt ()
| Used by boost::intrusive_pointer.
void | unref () const
| Used by boost::intrusive_pointer.
WeakPtr | weakPtr () const
| RefBase ()
| RefBase (const RefBase &)
| Copy constructor.
RefBase & | operator= (const RefBase &)
| Assignment operator.
virtual | ~RefBase ()
| Destructor.
virtual bool | checkRTTI (const char *typenameStr)=0
| This function is only implemented by concrete classes and triggers the actual RTTI check through matchRTTI();.
bool | matchRTTI (const char *typenameStr)
| Performs a check to see if the given typename string matches this class' This needs to be implemented in -all- subclasses, even abstract ones.
Public Member Functions inherited from MetadataCallback
virtual void | metadataHasChanged (const std::string &)
| Alerts the callback holder that the metadata has changed.

## Additional Inherited Members

Public Types inherited from MIPField< SparseField< Data_T > >
typedef MIPField< SparseField< Data_T > > | class_type
typedef CubicMIPFieldInterp< Data_T > | CubicInterp
typedef SparseField< Data_T >::value_type | Data_T
typedef SparseField< Data_T >::Ptr | FieldPtr
typedef std::vector< FieldPtr > | FieldVec
typedef MIPLinearInterp< MIPField< SparseField< Data_T > > > | LinearInterp
typedef SparseField< Data_T > | NestedType
typedef EmptyField< Data_T > | ProxyField
typedef ProxyField::Ptr | ProxyPtr
typedef std::vector< ProxyPtr > | ProxyVec
typedef boost::intrusive_ptr< MIPField > | Ptr
typedef Data_T | value_type
typedef std::vector< Ptr > | Vec
Public Types inherited from MIPBase< SparseField< Data_T >::value_type >
typedef MIPBase< Data_T > | class_type
typedef boost::intrusive_ptr< MIPBase > | Ptr
Public Types inherited from Field< Data_T >
typedef Field< Data_T > | class_type
typedef boost::intrusive_ptr< Field > | Ptr
typedef Data_T | value_type
| Allows us to reference the template class.
typedef std::vector< Ptr > | Vec
| This is a convenience typedef for the list that Field3DInputFile::readScalarLayers() and Field3DInputFile::readVectorLayers() will return its data in.
Public Types inherited from FieldRes
typedef FieldRes | class_type
typedef boost::intrusive_ptr< FieldRes > | Ptr
typedef std::vector< Ptr > | Vec
Public Types inherited from FieldBase
typedef FieldBase | class_type
typedef boost::intrusive_ptr< FieldBase > | Ptr
Public Types inherited from RefBase
typedef boost::intrusive_ptr< RefBase > | Ptr
typedef boost::weak_ptr< RefBase > | WeakPtr
Static Public Member Functions inherited from MIPField< SparseField< Data_T > >
static DEFINE_FIELD_RTTI_CONCRETE_CLASS const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from MIPBase< SparseField< Data_T >::value_type >
static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from Field< Data_T >
static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from FieldRes
static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from FieldBase
static const char * | staticClassName ()
static const char * | staticClassType ()
static const char * | staticClassType ()
| FIELD3D_CLASSNAME_CLASSTYPE_IMPLEMENTATION
Public Attributes inherited from MIPBase< SparseField< Data_T >::value_type >
| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from Field< Data_T >
| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from FieldRes
| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from FieldBase
std::string | attribute
| Optional name of the attribute the field represents.
std::string | name
| Optional name of the field.
Protected Types inherited from MIPField< SparseField< Data_T > >
typedef MIPBase< Data_T > | base
Protected Types inherited from MIPBase< SparseField< Data_T >::value_type >
typedef Field< Data_T > | base
Protected Types inherited from FieldRes
typedef MatrixFieldMapping | default_mapping
Protected Member Functions inherited from MIPField< SparseField< Data_T > >
const MIPField & | init (const MIPField &rhs)
| Copies from a second MIPField.
void | loadLevelFromDisk (size_t level) const
| Loads the given level from disk.
void | sanityChecks (const T &fields)
| Sanity checks to ensure that the provided Fields are a MIP representation.
void | syncLevelInfo (const size_t level) const
| Updates the name, attribute and metadata for a given level.
void | updateAuxMembers () const
| Updates the dependent data members based on m_field.
void | updateMapping (FieldRes::Ptr field)
| Updates the mapping, extents and data window to match the given field. Used so that the MIPField will appear to have the same mapping in space as the level-0 field.
Protected Attributes inherited from MIPField< SparseField< Data_T > >
std::vector< FieldPtr > | m_fields
| Storage of all MIP levels. Some or all of the pointers may be NULL. This is mutable because it needs updating during lazy loading of data.
boost::shared_ptr< boost::mutex > | m_ioMutex
| Mutex lock around IO. Used to make sure only one thread reads MIP level data at a time. When a field is cloned, the two new fields will share the mutex, since they point to the same file.
LazyLoadAction< SparseField< Data_T > >::Vec | m_loadActions
| Lazy load actions. Only used if setupLazyLoad() has been called.
std::vector< V3i > | m_mipRes
| Resolution of each MIP level.
std::vector< SparseField< Data_T > * > | m_rawFields
| Raw pointers to MIP levels.
std::vector< V3f > | m_relativeResolution
| Relative resolution of each MIP level. Pre-computed to avoid int-to-float conversions.
Protected Attributes inherited from MIPBase< SparseField< Data_T >::value_type >
size_t | m_lowestLevel
| The lowest MIP level to use. Defaults to 0, but can be set higher to prevent high resolution levels from being accessed.
V3i | m_mipOffset
| Base coordinate offset. This is used to indicate where voxel space coordinate (0, 0, 0) really maps to.
size_t | m_numLevels
| Number of MIP levels. The default is 1.
Protected Attributes inherited from FieldRes
Box3i | m_dataWindow
| Defines the area where data is allocated. This should be treated as a closed (i.e. inclusive) interval.
Box3i | m_extents
| Defines the extents of the the storage. This may be larger or smaller than the data window, and in the case where it is larger, care must be taken not to access voxels outside the data window. This should be treated as a closed (i.e. inclusive) interval.
FieldMapping::Ptr | m_mapping
| Pointer to the field's mapping.
Static Protected Attributes inherited from MIPField< SparseField< Data_T > >
static NestedFieldType< MIPField< SparseField< Data_T > > > | ms_classType
Static Protected Attributes inherited from MIPBase< SparseField< Data_T >::value_type >
static TemplatedFieldType< MIPBase< Data_T > > | ms_classType

## Detailed Description

template<typename Data_T>
class MIPSparseField< Data_T >

Definition at line 298 of file MIPField.h.

## Member Function Documentation

## clone()

template<typename Data_T>

virtual FieldBase::Ptr MIPSparseField< Data_T >::clone | ( |  | ) | const

inline virtual

Returns a pointer to a copy of the field, pure virtual so ensure derived classes properly implement it.

Reimplemented from MIPField< SparseField< Data_T > >.

Definition at line 301 of file MIPField.h.

{
return FieldBase::Ptr(new MIPSparseField(*this));
}
FieldBase::Ptr
boost::intrusive_ptr< FieldBase > Ptr
Definition Field.h:97
MIPSparseField
Definition MIPField.h:299

The documentation for this class was generated from the following file:

- export/MIPField.h